<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.text.SimpleDateFormat"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String today = new SimpleDateFormat("yyyyMMdd").format(new Date());
	final String name = request.getParameter("name");
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~histology_score.js" 
	styles="path.css,toolbar.css,~../css/reggie-2.css"
	>
<style>

.input
{
	padding: 0 !important;
}

input.score
{
	width: 6em !important;
	text-align: right;
	padding-right: 4px;
}

#he-glass-container
{
	white-space: nowrap;
	overflow: auto;
}

.he-glass
{
	display: inline-block;
	border-width: 1px;
	margin: 1em 1em 0.5em 1em;
	width: 20em;
}

.he-name
{
	font-weight: bold; 
	border-bottom-width: 1px; 
	padding: 0.25em;
}

.he-info
{
	background-color: #FFFFFF; 
	border-bottom-width: 1px;
	padding: 0.25em;
	height: 5em;
	overflow: auto;
	white-space: normal;
}

.he-info .ihc:before
{
	content: 'IHC: ';
}

.he-tray:before
{
	content: 'Tray: ';
}

.he-position:before
{
	content: 'Position: ';
}

.he-comment
{
	font-style: italic;
}


#score-container
{
	clear: both;
}

.he-table
{
	margin-top: 1em;
	margin-bottom: 1em;
	margin-left: auto;
	margin-right: auto;
	border: 1px solid #A0A0A0;
	border-collapse: separate;
}

.he-table td
{
	width: 8.5em;
	height: 8.5em;
	border: 1px solid #A0A0A0;
	padding: 2px;
	background: #FFFFFF;
	background-position: center center;
	background-repeat: no-repeat;
	vertical-align: top;
	text-align: center;
	font-size: 75%;
	color: #666666;
	cursor: pointer;
}

.he-table td.used:not(.ihc):hover
{
	border: 2px solid #2288AA;
	border-radius: 4px;
	padding: 1px;
}

.he-table td.ihc
{
	background-image: url('../images/microscope.png');
	cursor: default;
}

.he-table td.not-used
{
	background-color: #D0D0D0;
	background-image: url('../images/not-used.png');
	cursor: default;
}

.he-table td.selected
{
	background-color: #D8FFFF;
}

.he-table td.good-stain
{
	font-weight: bold;
	color: #000000;
}

.he-table td.good-stain.score-none
{
	background-image: url('../images/score-none.png');
}

.he-table td.good-stain.score-incomplete
{
	background-image: url('../images/score-incomplete.png');
}

.he-table td.good-stain.score-complete
{
	background-image: url('../images/score-complete.png');
}

.he-table td.flag
{
	background-image: url('../images/flag.png');
}

td.modified .sample-name:after
{
	content: ' *';
	color: #2244FF;
}

/* Hide progress by default */
.progress
{
	display: none;
}

/* Show progress for GoodStain, IHC or total score > 0 */
td.good-stain .progress, td.score-incomplete .progress, td.score-complete .progress, td.ihc .progress
{
	display: block;
}

td.score-incomplete .progress:before
{
	content: '(';
}
td.score-incomplete .progress:after
{
	content: ')';
}

.score-align
{
	width: 6em; 
	display: inline-block;
	padding: 3px;
	text-align: right;
}

#score_total
{
	font-weight: bold;
	padding-right: 6px;
}

#select-uncompleted-heglass-menu
{
	max-height: 20em;
	overflow: auto;
}

#select-uncompleted-heglass .menuitem
{
	padding-left: 16px;
}

#select-uncompleted-heglass .menuitem:hover
{
	padding-left: 14px;
	background-position: 0px 50%;
}
</style>

</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register HE glass score" 
		/></p:path>

	<div class="content">
	
	<div id="select-uncompleted-heglass" class="menu vertical bg-filled-100" style="width: 150px; display: none; z-index: 999;">
		<div id="select-uncompleted-heglass-menu"></div>
	</div>
	
	<form name="reggie" id="wizard" class="wizard">
	
	<div id="page-data" class="datacontainer"
		data-he-glass="<%=HTML.encodeTags(name)%>"
	></div>
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">HE glass to score</div>
		<div class="step-content">

			<tbl:toolbar subclass="bottomborder bg-filled-50">
				<tbl:label style="padding: 0; padding-left: 1em;" subclass="bg-filled-100">
				<input type="text" name="findGlassName" id="findHeGlassName"
					style="width: 12em;"
					placeholder="Find HE glass" title="Enter a full HE glass name or the last digits in the it's number before the dot"
					><base:icon id="btnFindHeGlass" image="<%=home+"/images/gonext.png"%>"></base:icon>
				</tbl:label>
			
				<tbl:button 
					id="btnSelectHeGlass"
					title="Select HE glass&hellip;" 
					image="<%=home + "/images/microscope.png"%>" 
					tooltip="Manually select a different HE glass"
				/>

				<tbl:button
					id="btnUncompletedHeGlass"
					title="Loading..."
					image="mini_scroll_down.png"
					tooltip="This list contain HE glass with partial scores"
				/>

			</tbl:toolbar>
			
			<div id="he-glass-container" style="display: none;">
			</div>
			
			<div id="score-container" style="display: none;">
				<div style="margin-left: 1em; margin-bottom: 0.5em;">
					<base:icon image="<%=home + "/images/flag.png"%>" />=No GoodStain sample for that location. 
					The Histology piece will be added to the <i>Flagged histology</i> list.
					<base:icon image="<%=home + "/images/microscope.png"%>" />=IHC staining. No scoring for this sample.
				</div>
				
				<table class="step-form">
				<tr class="section-header topborder bottomborder">
					<td>Sample</td>
					<td colspan="3" id="sample.name"></td>
				</tr>
				
				<tr>
					<td class="prompt">GoodStain</td>
					<td class="input">
						<span class="score-align"><input type="checkbox" name="good_stain" id="good_stain"
						title="Mark this checkbox to overtake the GoodStain annotation"
						></span>
					</td>
					<td class="status" id="good_stain.status"></td>
					<td class="help" rowspan="2">
						Check to overtake the GoodStain annotation. 
						Disabled if this sample is already annotated.
					</td>
				</tr>
				
				<tr>
					<td class="prompt">Scores</td>
					<td class="input"></td>
					<td class="status"></td>
				</tr>
				<tr>
					<td class="subprompt">Invasive cancer</td>
					<td class="input">
						<input type="text" class="score auto-init" name="score_invasive_cancer" id="score_invasive_cancer"
							data-auto-init="focus-on-enter" data-next-focus="score_insitu_cancer"
							maxlength="3">%
					</td>
					<td class="status" id="score_invasive_cancer.status"></td>
					<td class="help" rowspan="2">
						Enter the percentage for each cell type. 
						They must sum up to 100% before scoring can be compeleted.
					</td>
				</tr>		

				<tr>
					<td class="subprompt">In situ cancer</td>
					<td class="input">
						<input type="text" class="score auto-init" name="score_insitu_cancer" id="score_insitu_cancer" 
							data-auto-init="focus-on-enter" data-next-focus="score_lymphocytes"
							maxlength="3">%
					</td>
					<td class="status" id="score_insitu_cancer.status"></td>
				</tr>		
				<tr>
					<td class="subprompt">Lymphocytes</td>
					<td class="input">
						<input type="text" class="score auto-init" name="score_lymphocytes" id="score_lymphocytes"
							data-auto-init="focus-on-enter" data-next-focus="score_normal"
							maxlength="3">%
					</td>
					<td class="status" id="score_lymphocytes.status"></td>
					<td class="help"></td>
				</tr>		
				<tr>
					<td class="subprompt">Normal</td>
					<td class="input">
						<input type="text" class="score auto-init" name="score_normal" id="score_normal"
							data-auto-init="focus-on-enter" data-next-focus="score_stroma"
							maxlength="3">%
					</td>
					<td class="status" id="score_normal.status"></td>
					<td class="help"></td>
				</tr>		
				<tr>
					<td class="subprompt">Stroma</td>
					<td class="input">
						<input type="text" class="score auto-init" name="score_stroma" id="score_stroma"
							data-auto-init="focus-on-enter" data-next-focus="score_fat"
							maxlength="3">%
					</td>
					<td class="status" id="score_stroma.status"></td>
					<td class="help"></td>
				</tr>		
				<tr>
					<td class="subprompt">Fat</td>
					<td class="input">
						<input type="text" class="score auto-init" name="score_fat" id="score_fat"
							data-auto-init="focus-on-enter" data-next-focus="comments"
							maxlength="3">%
					</td>
					<td class="status" id="score_fat.status"></td>
					<td class="help"></td>
				</tr>
				<tr class="section-header">
					<td class="subprompt" style="font-weight: bold;">Total</td>
					<td class="input" style="padding: 0;"><span class="score-align" id="score_total"></span>%</td>
					<td class="status" id="score_total.status"></td>
					<td class="help"><span class="message" id="score_total.message"></span></td>
				</tr>
				
				<tr>
					<td class="subprompt">Score complete</td>
					<td class="input">
						<span class="score-align"><input type="checkbox" name="score_complete" id="score_complete"
							title="Uncheck if scoring is not complete"></span>
					</td>
					<td class="status" id="score_complete.status"></td>
					<td class="help">
						Uncheck if scoring is not complete. Disabled if some scores 
						are missing or the total score is not 100%.
					</td>
				</tr>
				
				<tr class="align-top">
					<td class="prompt">Comments</td>
					<td class="input">
						<textarea rows="3" name="comments" id="comments"></textarea>
					</td>
					<td class="status"></td>
					<td class="help"></td>
				</tr>
				</table>
			</div>
		</div>
	</div>
	

	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gonext" title="Next HE glass set" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/gonext.png"%>"  /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>